﻿using System;
using System.Collections.Generic;
using System.Text;
using org.apache.fop;
using org.apache.fop.apps;
using org.xml.sax;
using java.io;
using System.Xml;
using System.IO;

namespace MyComponent
{
    public class DocumentGenerator
    {

        // Method to generate a PDF binay using a FO file
        public static sbyte[] GeneratePDF(string sFoFileContent)
        {
            sbyte[] buf;
            try
            {
                InputSource source = new InputSource(new java.io.StringReader(sFoFileContent));
                source.setEncoding("WINDOWS-1250");
                ByteArrayOutputStream stream = new ByteArrayOutputStream();
                Driver driver = new Driver(source, stream);
                driver.setRenderer(1);
                driver.run();
                buf = stream.buf;
            }
            catch (Exception exception)
            {
                throw new ApplicationException(exception.Message);
            }
            return buf;
        }

        // Generate an string from a binary file
        public static string ArrayConvertToString(sbyte[] oSBytes)
        {
            byte[] oBytes = new byte[oSBytes.Length];
            System.Buffer.BlockCopy(oSBytes, 0, oBytes, 0, oBytes.Length);
            UTF8Encoding utf = new UTF8Encoding();
            return utf.GetString(oBytes);
        }

        // Generate a binary array from an string
        public static sbyte[] GenerateBinary(string Content)
        {
            System.Text.UTF8Encoding encoding = new System.Text.UTF8Encoding();
            byte[] data = encoding.GetBytes(Content);
            sbyte[] salida = new sbyte[data.Length];
            System.Buffer.BlockCopy(data, 0, salida, 0, salida.Length);
            return salida;
        }

        // tranform XML using a tranformation XSLT
        public static string TransformXML(string xml, string xslt)
        {
            XmlDocument xdRes = new XmlDocument();
            xdRes.LoadXml(xml);
            XmlDocument xslResponse = new XmlDocument();
            xslResponse.InnerXml = xslt;

            // Get bytes for xml document             
            byte[] oXml = System.Text.UTF8Encoding.UTF8.GetBytes(xdRes.OuterXml);
            byte[] oXsl = System.Text.UTF8Encoding.UTF8.GetBytes(xslResponse.OuterXml);

            // Build the memory stream with xml and xsl contents
            MemoryStream xslMemStream = new MemoryStream(oXsl);
            MemoryStream xmlMemStream = new MemoryStream(oXml);

            // Build the xml reader with the XSL and the XPath doc with the XML
            XmlTextReader xslReader = new XmlTextReader(xslMemStream);
            System.Xml.XPath.XPathDocument xPathDocXml = new System.Xml.XPath.XPathDocument(xmlMemStream);

            System.Xml.Xsl.XslCompiledTransform xslTransformer = new System.Xml.Xsl.XslCompiledTransform(true);
            xslTransformer.Load(xslReader);

            Stream resultStream = new MemoryStream();
            XmlWriter xmlWriter = new XmlTextWriter(resultStream, System.Text.Encoding.UTF8);

            xslTransformer.Transform(xPathDocXml, xmlWriter);
            xmlWriter.Flush();
            resultStream.Position = 0;

            // Get the result
            XmlDocument resultXmlDoc = new XmlDocument();
            try
            {
                resultXmlDoc.Load(resultStream);
            }
            catch
            {
                resultStream.Position = 0;
                StreamReader resultReader = new StreamReader(resultStream);
                string sResultText = resultReader.ReadToEnd();
            }
            return resultXmlDoc.OuterXml;
        }
    }
}
